#include <stdio.h>
#include <allegro.h>

#include <aldumb.h>

//#include <mikmod.h>

#include "easymik.h"

//#include <aastr.h>

// #include <jonipx.h>

#include "cars.h"
#include "gamedata.h"
#include "tiledata.h"
#include "sound.h"

#define MAXACCEL 13
#define CATACCEL 4
#define NUM_CATS 30

// define IPX stuff
/*
#define PACKET_JOIN_GAME 1
#define PACKET_QUIT_GAME 2
#define PACKET_CAR_INFO 3
#define PACKET_CAT_DATA 4
#define PACKET_ASSIGN_SERVER 5
#define PACKET_HIT_CAT 6
#define PACKET_MSG 7
*/

typedef struct CAR
{
fixed turn;
int accel;
int x;
int y;
BITMAP *bmp;
int carnum;
} CAR;

typedef struct CAT
{
fixed turn;
char state;
int x;
int y;
int destx;
int desty;
} CAT;

typedef struct MAP
{
int x;
int y;
unsigned char *map;
} MAP;

DATAFILE *tiles;
DATAFILE *cardata;
DATAFILE *gamedata;
DATAFILE *snddata;

BITMAP *buffer;
BITMAP *radar;
BITMAP *scalebuf;

MSAMPLE *hit1;
MSAMPLE *click;
MSAMPLE *ok;

MAP map;
CAR *car = NULL;
CAT cats[NUM_CATS];

RGB_MAP rgb_table;

/*
node_address_type node_address = {0xff, 0xff, 0xff, 0xff, 0xff, 0xff};;
game_packet_type packet;
string_type string;
*/

int mapx;
int mapy;
char playernum = 0;
char numplayers = 0;

int catcount;

//int screen_x;
//int screen_y;

/*
char talkstr[80];
char talkstrindex;

char server; // server flag
*/

volatile char frameready; // frame-ready flag

// framerate stuff
void FrameReady()
{
frameready = 1;
}
END_OF_FUNCTION(FrameReady);
// Network crap
/*
void SendCatData(char index)
{
      sprintf(string,"%c%c%c%c%c%c%c%c%c%c%c",PACKET_CAT_DATA,
                                                       index,
                                                cats[index].state,
                             cats[index].x / 64, cats[index].x % 64,
                             cats[index].y / 64, cats[index].y % 64,
                          cats[index].destx / 64, cats[index].destx % 64,
                          cats[index].desty / 64, cats[index].desty % 64);
      Jon_Send_Packet(string,11,node_address);
}

void SendAllCatData(void)
{
   char index;

   for(index = 0; index < NUM_CATS; index ++)
      SendCatData(index);
}

void GetGameInfo(void)
{

   while( Packet_Ready() )
   {
      Pop_Packet( &packet );
      switch(packet.string[0])
      {
         case PACKET_JOIN_GAME:
            if(numplayers < packet.string[1] + 1)
            {
               numplayers = packet.string[1] + 1;
               car = realloc(car, sizeof(CAR) * numplayers);
            }
            car[packet.string[1]].bmp = cardata[packet.string[2]].dat;

            if(server)
               SendAllCatData();
            break;
         case PACKET_CAR_INFO:
            if(numplayers < packet.string[1] + 1)
            {
               numplayers = packet.string[1] + 1;
               car = realloc(car, sizeof(CAR) * numplayers);
            }
            car[packet.string[1]].bmp = cardata[packet.string[2]].dat;
            car[packet.string[1]].x = packet.string[3] * 64 + packet.string[4];
            car[packet.string[1]].y = packet.string[5] * 64 + packet.string[6];
            car[packet.string[1]].turn = itofix(packet.string[7] * 64 + packet.string[8]);
            break;
         case PACKET_QUIT_GAME:
            if(numplayers < packet.string[1] + 1)
            {
               numplayers = packet.string[1] + 1;
               car = realloc(car, sizeof(CAR) * numplayers);
            }
            car[packet.string[1]].bmp = NULL;
            break;
         case PACKET_CAT_DATA:
            cats[packet.string[1]].state = packet.string[2];
            cats[packet.string[1]].x = packet.string[3] * 64 + packet.string[4];
            cats[packet.string[1]].y = packet.string[5] * 64 + packet.string[6];
            cats[packet.string[1]].destx = packet.string[7] * 64 + packet.string[8];
            cats[packet.string[1]].desty = packet.string[9] * 64 + packet.string[10];
            break;
         case PACKET_ASSIGN_SERVER:
            if(packet.string[1] == playernum)
               server = 1;
            break;
         case PACKET_HIT_CAT:
            cats[packet.string[1]].state = CATDIE1;
            play_wav(hit1);
            break;
         case PACKET_MSG:
            strcpy(talkstr,&(packet.string[1]));
            talkstrindex = strlen(talkstr);
            break;
      }
   }
}

void SendQuitMsg(void)
{
sprintf(string,"%c%c",PACKET_QUIT_GAME,playernum);
Jon_Send_Packet(string,2,node_address);
}

void SendGameInfo(void)
{
sprintf(string,"%c%c%c%c%c%c%c%c%c",PACKET_CAR_INFO, playernum, car[playernum].carnum,
                                car[playernum].x / 64, car[playernum].x % 64,
                                car[playernum].y / 64, car[playernum].y % 64,
                                fixtoi(car[playernum].turn) / 64, fixtoi(car[playernum].turn) % 64);
Jon_Send_Packet(string,9,node_address);
}

void AssignNewServer(void)
{
unsigned char index;
for(index = 0; index < numplayers; index++)
{
   if(car[index].bmp == NULL) // player has quit
      continue;
   sprintf(string, "%c%c", PACKET_ASSIGN_SERVER, index);
   Jon_Send_Packet(string,2,node_address);
}
}
*/

// Double buffer func

void DrawDoubleBuf()
{
//aa_stretch_blit(buffer,scalebuf,0,0,320,200,0,0,screen_x / 2,screen_y / 2);
vsync();
stretch_blit(buffer,screen,0,0,320,200,0, 0, SCREEN_W, SCREEN_H);
//blit(buffer,screen,0,0,0,0,screen_x, screen_y);
}

// Cat funcs

void InitCats()
{
int index;

for(index=0;index<NUM_CATS;index++)
{
   cats[index].state=CAT1;
   cats[index].x = rand() % (map.x * 32);
   cats[index].y = rand() % (map.y * 32);
   cats[index].destx = rand() % (map.x * 32);
   cats[index].desty = rand() % (map.y * 32);
}
}

void MoveCats()
{
int index;
int xturn;
int yturn;

for(index=0; index < NUM_CATS; index++)
{

   if(cats[index].state != CATDIE1 && cats[index].state != CATDIE2 && cats[index].state != CATDIE3)
   {
      cats[index].turn = abs(fatan(fdiv(itofix(cats[index].destx - cats[index].x),itofix(cats[index].desty - cats[index].y))));
      xturn=fixtoi(fsin(cats[index].turn) * 4);
      yturn=fixtoi(fcos(cats[index].turn) * 4);

      if(cats[index].desty > cats[index].y && cats[index].destx > cats[index].x)
      {
         yturn -= (yturn * 2);
         cats[index].turn = itofix(128) - cats[index].turn;
      }
      if(cats[index].desty > cats[index].y && cats[index].destx < cats[index].x)
      {
         xturn -= (xturn * 2);
         yturn -= (yturn * 2);
         cats[index].turn += itofix(128);
      }
      if(cats[index].desty < cats[index].y && cats[index].destx < cats[index].x)
      {
         xturn -= (xturn * 2);
         cats[index].turn = itofix(255) - cats[index].turn;
      }

      cats[index].x += xturn;
      cats[index].y -= yturn;

      if(abs(cats[index].destx - cats[index].x) < 4 && abs(cats[index].desty - cats[index].y) < 4)
      {
         cats[index].destx = rand() % (map.x * 32);
         cats[index].desty = rand () % (map.y * 32);
         /*if(server)
            SendCatData(index);*/
      }
   }

   switch(cats[index].state)
   {
      case CAT1:
         cats[index].state = CAT2;
         break;
      case CAT2:
         cats[index].state = CAT3;
         break;
      case CAT3:
         cats[index].state = CAT4;
         break;
      case CAT4:
         cats[index].state = CAT1;
         break;
      case CATDIE1:
         cats[index].state = CATDIE2;
         break;
      case CATDIE2:
         cats[index].state = CATDIE3;
      default:
         break;
   }
}
}

void DrawCats()
{
int index;

for(index = 0; index < NUM_CATS; index++)
{
   // Test whether we can see it
   if(cats[index].x < mapx - 32)
      continue;
   if(cats[index].y < mapy - 32)
      continue;
   if(cats[index].x > mapx + 320)
      continue;
   if(cats[index].y > mapy + 200)
      continue;

   // now draw, damn you.
   rotate_sprite(buffer, (BITMAP*)gamedata[cats[index].state].dat, cats[index].x - mapx /*+ 16*/, cats[index].y - mapy /*+ 16*/, cats[index].turn + itofix(128));
}
}

void CollideCats()
{
int index;
int relx;
int rely;
int r;
fixed ang;


for(index=0; index<NUM_CATS; index++)
{
if(car[playernum].turn <= itofix(64))
   ang = itofix(64) - car[playernum].turn;
else
if(car[playernum].turn <= itofix(128))
   ang = itofix(128) - car[playernum].turn + itofix(64);
else
if(car[playernum].turn <= itofix(192))
   ang = itofix(192) - car[playernum].turn + itofix(128);
else
   ang = itofix(256) - car[playernum].turn + itofix(192);

relx = fixtoi( fsin(ang) * ( cats[index].x - car[playernum].x - (car[playernum].bmp->w / 2) + 16 ) ) +
       fixtoi( fcos(ang) * (cats[index].y - car[playernum].y - (car[playernum].bmp->h / 2) + 16 ) ) + car[playernum].x + (car[playernum].bmp->w / 2); 
rely = fixtoi( fsin(ang) * ( cats[index].y - car[playernum].y - (car[playernum].bmp->h /2)  + 16) ) -
       fixtoi( fcos(ang) * ( cats[index].x - car[playernum].x - (car[playernum].bmp->w / 2) + 16) ) + car[playernum].y + (car[playernum].bmp->h / 2);

if(relx >= car[playernum].x && rely >= car[playernum].y && relx <= car[playernum].x + (car[playernum].bmp->w) && rely <= car[playernum].y + (car[playernum].bmp->h))
   if(car[playernum].accel != 0 && cats[index].state != CATDIE3 && cats[index].state != CATDIE2)
   {                                                                                
      cats[index].state = CATDIE1;
      play_wav(hit1);
      catcount ++;
      /*
      sprintf(string,"%c%c",PACKET_HIT_CAT, index);
      Jon_Send_Packet(string,2,node_address);
      */

   }
   else
   {
      cats[index].destx = rand() % (map.x * 32);
      cats[index].desty = rand() % (map.y * 32);
      /*SendCatData(index);*/
   }
}
}

// Map funcs

void LoadMap(char *fn)
{
FILE *fp;

fp=fopen(fn, "rb");
fread(&map.x, sizeof(int), 1, fp);
fread(&map.y, sizeof(int), 1, fp);
map.map = (unsigned char*)realloc(map.map, map.x * map.y);
fread(map.map, sizeof(unsigned char), map.x * map.y, fp);
fclose(fp);
}

void DrawMap(int x, int y)
{
int startx;
int starty;
int lx;
int ly;
int tilefind;
int sx;
int sy;

startx = x / 32;
starty = y / 32;

for(lx=0; lx<11; lx++)
   for(ly=0; ly<8; ly++)
   {
      tilefind = (lx + startx) + ((ly + starty) * map.x);
      if (tilefind >= map.x * map.y)
         continue;
      sx = (startx * 32) - x + (lx * 32);
      sy = (starty * 32) - y + (ly * 32);
      blit((BITMAP*)tiles[map.map[tilefind]].dat, buffer, 0,0,sx,sy,32,32);
   }
}

// gameplay funcs

void CheckBoundaries()
{
int cmx;
int cmy;

if(mapx < 0)
   mapx = 0;
if(mapy < 0)
   mapy = 0;
if(mapx > (map.x * 32) - 320)
   mapx = (map.x * 32) - 320;
if(mapy > (map.y * 32) - 200)
   mapy = (map.y * 32) - 200;

cmx = car[playernum].x + (car[playernum].bmp->w / 2);
cmy = car[playernum].y + (car[playernum].bmp->h / 2);

if (cmx < 0)
   car[playernum].x = -(car[playernum].bmp->w / 2);
if (cmy < 0)
   car[playernum].y = -(car[playernum].bmp->h / 2);
if (cmx > (map.x * 32))
   car[playernum].x = (map.x * 32) - (car[playernum].bmp->w / 2) - 1;
if (cmy > (map.y * 32))
   car[playernum].y = (map.y * 32) - (car[playernum].bmp->h / 2) - 1;
}


void CalcAccel()
{
if(car[playernum].accel - 5 < -5 && key[KEY_DOWN])
   car[playernum].accel = -5;
else
if(car[playernum].accel - 5 < 0)
   car[playernum].accel = 0;
else
   car[playernum].accel -= 5;

if(car[playernum].accel > MAXACCEL)
   car[playernum].accel = MAXACCEL;
// Might as well check rotation here
if(car[playernum].turn < 0)
   car[playernum].turn += itofix(256);
if(car[playernum].turn > itofix(256))
   car[playernum].turn -= itofix(256);

car[playernum].x += fixtoi(fsin(car[playernum].turn)*car[playernum].accel);
car[playernum].y -= fixtoi(fcos(car[playernum].turn)*car[playernum].accel);
}

void GetInput()
{
int index;
int keyp;

if(key[KEY_LEFT])
   car[playernum].turn -= itofix(8);
if(key[KEY_RIGHT])
   car[playernum].turn += itofix(8);
if(key[KEY_UP])
   car[playernum].accel += 7;
if(key[KEY_DOWN])
   car[playernum].accel -= 2;

if(keypressed())
{
   keyp = readkey();
   /*
   if(keyp >> 8 == KEY_ENTER)
   {
      talkstrindex = 0;
      talkstr[0] = '\0';
      sprintf(string,"%c%s", PACKET_MSG, talkstr);
      Jon_Send_Packet(string,talkstrindex + 2,node_address);
   }
   else
   */
   if(keyp >> 8 == KEY_F1)
   {
      for(index = 0; index < NUM_CATS; index++)
         cats[index].state = CAT1;
      /*SendAllCatData();*/
   }
   /*
   else
   if(keyp >> 8 == KEY_BACKSPACE)
   {
      talkstrindex --;
      if(talkstrindex < 0)
         talkstrindex = 0;
      talkstr[talkstrindex] = 0;
   }
   else
   {
      if(talkstrindex != 79)
      {
         sprintf(talkstr, "%s%c", talkstr, keyp & 0xff);
         talkstrindex ++;
         sprintf(string,"%c%s", PACKET_MSG, talkstr);
         Jon_Send_Packet(string, talkstrindex + 2, node_address);
      }
   }
   */
}
}
void DrawText()
{
            /*text_mode(-1);
            textout(buffer,gamedata[TALKFONT].dat,talkstr,0,170,-1);*/
}

void DrawCar(CAR *pCar)
{
if(pCar->bmp)
   rotate_sprite(buffer,pCar->bmp,pCar->x - mapx /*+ pCar->bmp->w / 2*/,pCar->y - mapy /*+ pCar->bmp->h / 2*/,pCar->turn+itofix(128));
}

void MoveMap()
{
mapx = (car[playernum].x + car[playernum].bmp->w / 2) - 160;
mapy = (car[playernum].y + car[playernum].bmp->h / 2) - 100;
}

void CatCount()
{
char text[3];
BITMAP *tbuf;

text_mode(0);
sprintf(text, "%d", catcount);
tbuf = create_bitmap(text_length((FONT*)gamedata[NUMFONT].dat,text), text_height((FONT*)gamedata[NUMFONT].dat));

draw_sprite(buffer,(BITMAP*)gamedata[CATCOUNT].dat, 5,5);
textout(tbuf,(FONT*)gamedata[NUMFONT].dat, text, 0, 0, -1);
draw_sprite(buffer,tbuf, 50, 12);

destroy_bitmap(tbuf);
}

// Radar funcs
void InitRadar()
{
int ix;
int iy;

radar = create_bitmap(80,50);

for(ix = 0; ix < 80; ix ++)
   for(iy = 0; iy < 50; iy ++)
      stretch_blit((BITMAP*)tiles[map.map[ix + (iy * 80)]].dat, radar,0,0,32,32,ix,iy,1,1);
}

void DrawRadar()
{
int index;

blit(radar,buffer,0,0,235,5,80,50);

for(index=0; index < NUM_CATS; index++)
   if(cats[index].state != CATDIE1 && cats[index].state != CATDIE2 && cats[index].state != CATDIE3)
      putpixel(buffer,cats[index].x / 32 + 235, cats[index].y / 32 + 5, 55);
   else
      putpixel(buffer,cats[index].x / 32 + 235, cats[index].y / 32 + 5, 40);

for(index = 0; index < numplayers; index++)
   if(car[index].bmp)
      putpixel(buffer,(car[index].x + car[index].bmp->w / 2) / 32 + 235, (car[index].y + car[index].bmp->h / 2) / 32 + 5, 32);
}

void RunGame()
{
int index;
mapx = mapy = 0;

LOCK_FUNCTION(FrameReady);
LOCK_VARIABLE(frameready);

install_int(FrameReady,50);

while(1)
{
   GetInput();
   CalcAccel();
   MoveCats();
   CollideCats();
   MoveMap();
   CheckBoundaries();
   DrawMap(mapx,mapy);
   DrawCats();
   for(index = 0; index < numplayers; index ++)
      DrawCar(&car[index]);
   CatCount();
   DrawRadar();
   /*DrawText();*/
   DrawDoubleBuf();
   /*SendGameInfo();
   GetGameInfo();*/
   poll_mod();
   
   while(frameready != 1);
   frameready = 0;

   if(key[KEY_ESC])
       break;
}
/*if(server)
   AssignNewServer();
SendQuitMsg();*/
}



// car selection func
int GetCar()
{
CAR cTmp;
char *carlookup[13];
char currcar;

carlookup[CAR0] = "Viper";
carlookup[CAR1] = "Jaguar";
carlookup[CAR2] = "Pickup";
carlookup[CAR3] = "Limo";
carlookup[CAR4] = "Fire Truck";
carlookup[CAR5] = "School Bus";
carlookup[CAR6] = "Police Car";
carlookup[CAR7] = "Semi";
carlookup[CAR8] = "Tank";
carlookup[CAR9] = "Tanker";
carlookup[CAR10] = "Ambulance";
carlookup[CAR11] = "Monster Bug";
carlookup[CAR12] = "Hippie Wagon";
currcar = CAR0;

mapx = 0;
mapy = 0;

while(!key[KEY_ENTER])
{
   if(keypressed())
   {
      switch(readkey() >> 8)
      {
         case KEY_LEFT:
            currcar --;
            if(currcar < CAR0)
               currcar = CAR9;
            play_wav(click);
            break;

         case KEY_RIGHT:
            currcar ++;
            if(currcar > CAR9)
               currcar = CAR0;
            play_wav(click);
            break;

         default:
            break;
      }
   }
   cTmp.turn += itofix(4);
   if(cTmp.turn > itofix(256))
      cTmp.turn -= itofix(256);

   cTmp.bmp = (BITMAP*)cardata[currcar].dat;
   cTmp.x = 160 - (cTmp.bmp->w / 2);
   cTmp.y = 100 - (cTmp.bmp->h / 2);

   clear(buffer);
   textout_centre(buffer,(FONT*)gamedata[F].dat,"Choose Your Car",160,10,-1);
   textout_centre(buffer,(FONT*)gamedata[F].dat,carlookup[currcar],160,150,-1);
   DrawCar(&cTmp);
   DrawDoubleBuf();
   rest(50);
   poll_mod();
   // Gather game info
   /*GetGameInfo();*/
      
}
play_wav(ok);

playernum = numplayers;
numplayers++;
car = (CAR*)realloc(car,sizeof(CAR) * numplayers);

/*sprintf(string,"%c%c%c",PACKET_JOIN_GAME,playernum,currcar);
Jon_Send_Packet(string,3,node_address);

if (playernum == 0)
   server = 1;
else
   server = 0;
*/
return currcar;
}


// main func

int main(int argc, char *argv[])
{
UNIMOD *mf;

allegro_init();
install_keyboard();
install_timer();
init_mikmod(DEVICE_AUTODETECT);

/*Allocate_Dos_Buffers();
Init_Jonipx();*/

// load datafiles
cardata=load_datafile("cars.dat");
gamedata=load_datafile("game.dat");
tiles=load_datafile("tile.dat");
snddata=load_datafile("sound.dat");

// load map
map.map = NULL;
LoadMap("map1.map");


// random number seed
srand( (unsigned)time( NULL ) );

playernum = 0;
numplayers = 0;
car = NULL;

// initialize radar
InitRadar();

// initalize cats
InitCats();

// Initialize double buffer
buffer = create_bitmap(320,200);

create_rgb_table (&rgb_table, (RGB*)gamedata[PAL].dat, 0);
rgb_map = &rgb_table;
puts("created RGB table");

set_gfx_mode(GFX_GDI,640,400,0,0);
set_palette((RGB*)gamedata[PAL].dat);

//screen_x = 320;
//screen_y = 200;

//scalebuf = create_bitmap(screen_x, screen_y);

mf = init_data_mod(&snddata[MUSIC1]);

play_mod(mf,1);

// load sounds
hit1 = init_data_wav(&snddata[HIT1]);
click = init_data_wav(&snddata[CLICK]);
ok = init_data_wav(&snddata[OK]);

if(hit1 == NULL || click == NULL || ok == NULL)
{
   set_gfx_mode(GFX_TEXT,80,25,0,0);
   puts(myerr);
   exit(1);
}
// initalize car
int carnum = GetCar();
car[playernum].carnum = carnum;
car[playernum].bmp = (BITMAP*)cardata[car[playernum].carnum].dat;
car[playernum].turn = 0;
car[playernum].accel = 0;
car[playernum].x = rand()%(map.x * 32);
car[playernum].y = rand()%(map.y * 32);

fade_out(10);
stop_mod();
free_mod(mf);

mf = init_data_mod(&snddata[MUSIC2]);
play_mod(mf,1);
set_palette((RGB*)gamedata[PAL].dat);

catcount = 0;

RunGame();
fade_out(10);
stop_mod();

free_mod(mf);
free_wav(hit1);
free_wav(click);
free_wav(ok);

destroy_bitmap(buffer);
destroy_bitmap(radar);

unload_datafile(cardata);
unload_datafile(gamedata);
unload_datafile(tiles);
unload_datafile(snddata);

end_mikmod();
/*Close_Jonipx(); */

}
END_OF_MAIN();
